#ifndef NOT_CHR3
;Project Lynxmotion Phoenix
;Description: chr-3, configuration file.
;		All Hardware connections (excl controls) and body dimensions 
;		are configurated in this file. Can be used with V2.0 and above
;Configuration version: V1.0
;Date: Nov 1, 2009
;Programmer: Jeroen Janssen (aka Xan) - modified for CHR-3 by Kurt (aka KurtE)
;
;Hardware setup: ABB2 with ATOM 28 Pro, SSC32 V2, (See further for connections)
;
;NEW IN V1.0
;	- First Release
;
;--------------------------------------------------------------------
;USEPS2			con	1		; Do we use the PS2?
USEXBEE			con 1		; and/or do we use XBEE?
;USERC			con 1		; and/or do we use RC


;[SERIAL CONNECTIONS]

;--------------------------------------------------------------------
;[BB2 PIN NUMBERS]
cEyesPin		con P0


#ifdef USE_SSC32
CXBEE_RTS		con P34

;[SSC PIN NUMBERS]
cRRCoxaPin 		con 0	;Rear Right leg Hip Horizontal
cRRFemurPin 	con 1	;Rear Right leg Hip Vertical
cRRTibiaPin 	con 2	;Rear Right leg Knee

cRMCoxaPin 		con 4	;Middle Right leg Hip Horizontal
cRMFemurPin 	con 5	;Middle Right leg Hip Vertical
cRMTibiaPin 	con 6	;Middle Right leg Knee

cRFCoxaPin 		con 8	;Front Right leg Hip Horizontal
cRFFemurPin 	con 9	;Front Right leg Hip Vertical
cRFTibiaPin 	con 10	;Front Right leg Knee

cLRCoxaPin 		con 16	;Rear Left leg Hip Horizontal
cLRFemurPin 	con 17	;Rear Left leg Hip Vertical
cLRTibiaPin 	con 18	;Rear Left leg Knee

cLMCoxaPin 		con 20	;Middle Left leg Hip Horizontal
cLMFemurPin 	con 21	;Middle Left leg Hip Vertical
cLMTibiaPin 	con 22	;Middle Left leg Knee

cLFCoxaPin 		con 24	;Front Left leg Hip Horizontal
cLFFemurPin 	con 25	;Front Left leg Hip Vertical
cLFTibiaPin 	con 26	;Front Left leg Knee
#else
;[ARC32 PIN NUMBERS]
cRRCoxaPin 		con P31	;Rear Right leg Hip Horizontal
cRRFemurPin 	con P30	;Rear Right leg Hip Vertical
cRRTibiaPin 	con P29	;Rear Right leg Knee

cRMCoxaPin 		con P28	;Middle Right leg Hip Horizontal
cRMFemurPin 	con P27	;Middle Right leg Hip Vertical
cRMTibiaPin 	con P26	;Middle Right leg Knee

cRFCoxaPin 		con P25	;Front Right leg Hip Horizontal
cRFFemurPin 	con P24	;Front Right leg Hip Vertical
cRFTibiaPin 	con P23	;Front Right leg Knee

cLRCoxaPin 		con P15	;Rear Left leg Hip Horizontal
cLRFemurPin 	con P14	;Rear Left leg Hip Vertical
cLRTibiaPin 	con P13	;Rear Left leg Knee

cLMCoxaPin 		con P12	;Middle Left leg Hip Horizontal
cLMFemurPin 	con P11	;Middle Left leg Hip Vertical
cLMTibiaPin 	con P10	;Middle Left leg Knee

cLFCoxaPin 		con P9	;Front Left leg Hip Horizontal
cLFFemurPin 	con P8	;Front Left leg Hip Vertical
cLFTibiaPin 	con P4	;Front Left leg Knee
#endif

cSound			con P20	; moved from 19-20 to free up WKP0 lets try output sound on plug in speaker
ENABLE_TA		con 1
;--------------------------------------------------------------------
;[MIN/MAX ANGLES]
cRRCoxaMin1		con -750		;Mechanical limits of the Right Rear Leg
cRRCoxaMax1		con 750
cRRFemurMin1	con -900
cRRFemurMax1	con 550
cRRTibiaMin1	con -400
cRRTibiaMax1	con 750

cRMCoxaMin1		con -750		;Mechanical limits of the Right Middle Leg
cRMCoxaMax1		con 750
cRMFemurMin1	con -900
cRMFemurMax1	con 550
cRMTibiaMin1	con -400
cRMTibiaMax1	con 750

cRFCoxaMin1		con -750		;Mechanical limits of the Right Front Leg
cRFCoxaMax1		con 750
cRFFemurMin1	con -900
cRFFemurMax1	con 550
cRFTibiaMin1	con -400
cRFTibiaMax1	con 750

cLRCoxaMin1		con -750		;Mechanical limits of the Left Rear Leg
cLRCoxaMax1		con 750
cLRFemurMin1	con -900
cLRFemurMax1	con 550
cLRTibiaMin1	con -400
cLRTibiaMax1	con 750

cLMCoxaMin1		con -750		;Mechanical limits of the Left Middle Leg
cLMCoxaMax1		con 750
cLMFemurMin1	con -900
cLMFemurMax1	con 550
cLMTibiaMin1	con -400
cLMTibiaMax1	con 750

cLFCoxaMin1		con -750		;Mechanical limits of the Left Front Leg
cLFCoxaMax1		con 750
cLFFemurMin1	con -900
cLFFemurMax1	con 550
cLFTibiaMin1	con -750
cLFTibiaMax1	con 400
;--------------------------------------------------------------------
;[BODY DIMENSIONS]
cCoxaLength 	con 29      ;1.14" = 29mm (1.14 * 25.4)
cFemurLength 	con  57     ;2.25" = 57mm (2.25 * 25.4)
cTibiaLength 	con  141    ;5.55" = 141mm (5.55 * 25.4)

cRRCoxaAngle1 	con -600	;Default Coxa setup angle, decimals = 1
cRMCoxaAngle1 	con 0		;Default Coxa setup angle, decimals = 1
cRFCoxaAngle1 	con 600		;Default Coxa setup angle, decimals = 1
cLRCoxaAngle1 	con -600	;Default Coxa setup angle, decimals = 1
cLMCoxaAngle1 	con 0		;Default Coxa setup angle, decimals = 1
cLFCoxaAngle1 	con 600		;Default Coxa setup angle, decimals = 1

cRROffsetX 		con -69     ;Distance X from center of the body to the Right Rear coxa
cRROffsetZ 		con 119     ;Distance Z from center of the body to the Right Rear coxa
cRMOffsetX 		con -138    ;Distance X from center of the body to the Right Middle coxa
cRMOffsetZ 		con 0       ;Distance Z from center of the body to the Right Middle coxa
cRFOffsetX 		con -69     ;Distance X from center of the body to the Right Front coxa
cRFOffsetZ 		con -119    ;Distance Z from center of the body to the Right Front coxa

cLROffsetX 		con 69      ;Distance X from center of the body to the Left Rear coxa
cLROffsetZ 		con 119     ;Distance Z from center of the body to the Left Rear coxa
cLMOffsetX 		con 138     ;Distance X from center of the body to the Left Middle coxa
cLMOffsetZ 		con 0       ;Distance Z from center of the body to the Left Middle coxa
cLFOffsetX 		con 69      ;Distance X from center of the body to the Left Front coxa
cLFOffsetZ 		con -119    ;Distance Z from center of the body to the Left Front coxa

;--------------------------------------------------------------------
;[START POSITIONS FEET]
cHexInitXZ		con 90		; was 105 
CHexInitY		con 80

cRRInitPosX 	con (cHexInitXZ * 0.5 + 0.5)		;Start positions of the Right Rear leg
cRRInitPosY 	con cHexInitY
cRRInitPosZ 	con (cHexInitXZ * 0.866 + 0.5)

cRMInitPosX 	con cHexInitXZ		;Start positions of the Right Middle leg
cRMInitPosY 	con cHexInitY
cRMInitPosZ 	con 0

cRFInitPosX 	con (cHexInitXZ * 0.5 + 0.5)		;Start positions of the Right Front leg
cRFInitPosY 	con cHexInitY
cRFInitPosZ 	con -(cHexInitXZ * 0.866 + 0.5)

cLRInitPosX 	con (cHexInitXZ * 0.5 + 0.5)		;Start positions of the Left Rear leg
cLRInitPosY 	con cHexInitY
cLRInitPosZ 	con (cHexInitXZ * 0.866 + 0.5)

cLMInitPosX 	con cHexInitXZ		;Start positions of the Left Middle leg
cLMInitPosY 	con cHexInitY
cLMInitPosZ 	con 0

cLFInitPosX 	con (cHexInitXZ * 0.5 + 0.5)		;Start positions of the Left Front leg
cLFInitPosY 	con cHexInitY
cLFInitPosZ 	con -(cHexInitXZ * 0.866 + 0.5)

;--------------------------------------------------------------------
#endif ; NOT_CHR3